local Populator = {}
Populator.Seeder = require 'Seeder'

local metatable = {}
metatable.__call = function (self, world)
	local seed = self.Seeder()

	for k,v in pairs(self.Rule) do
		if type(v) ~= 'function' then
			print(k..' is no function')
			return
		end
	end

	for i,v in ipairs(seed) do
		self.Rule.seedControl(self, v)

		local elem = self.Rule.contentControl(self, World)
		Populator.Rule.creationControl(self, World, elem)
	end
end

setmetatable(Populator, metatable)

Populator.Rule = {}

Populator.Rule.seedControl = nil
Populator.Rule.contentControl = nil
Populator.Rule.creationControl = nil
Populator.Rule.completionControl = nil

Populator.ruleControl = nil

return Populator
