Populator	= require 'Populator'

World = {
	level = {},
	debug = {},
	properties = {
		width = love.window.getWidth(),
		height = love.window.getHeight()
	},
	model = {
		model1 = {
			x = 0,
			y = 0,
			width = 10,
			height = 10,
			draw = function (self, mode)
				love.graphics.rectangle(mode, self.x,
					self.y, self.width, self.height)
			end
		},
		model2 = {
			x = 0,
			y = 0,
			radius = 0,
			draw = function (self, mode)
				love.graphics.circle(mode, self.x,
					self.y, self.radius)
			end
		}
	},
	new = function (table)
		local t = {}

		for k,v in pairs(table) do
			t[k] = v
		end
		return t
	end,
	draw = function (self)
		for i,v in ipairs(self.debug) do v:draw('line') end
		for i,v in ipairs(self.level) do v:draw('fill') end
	end
}

function love.load()
	Populator.Seeder.Quantity = 42
	Populator.Seeder.Rule = function (Seeder)
		return love.math.random(-1, 4)
	end

	Populator.x = 10
	Populator.y = love.window.getHeight() / 2
	Populator.Rule.seedControl = function (Populator, seed)
		if seed == -1 then
			Populator.y = Populator.y + World.model.model1.height / 2
		elseif seed == 1 then
			Populator.y = Populator.y - World.model.model1.height / 2
		end
	end
	Populator.Rule.contentControl = function (Populator, World)
		local elem = World.new(World.model.model1)
		elem.x = Populator.x
		elem.y = Populator.y
		Populator.x = Populator.x + World.model.model1.width + 2
		return elem
	end
	Populator.Rule.creationControl = function (Populator, World, elem)
		if #World.level > 3 then
			if elem.y == World.level[#World.level - 1].y
			and elem.y ~= World.level[#World.level].y then
				table.remove(World.level, #World.level)
			end
		end
		table.insert(World.level, elem)
		-- table.insert(World.debug, elem)
	end
	Populator(World)
end

function love.update(dt)
end

function love.draw()
	World:draw()
end
